##
## Copyright (c) 2021 The Yaook Authors.
##
## This file is part of Yaook.
## See https://yaook.cloud for further info.
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
FROM python:3.10.14-slim-bookworm

ARG openstack_release=2023.2
ARG branch=stable/${openstack_release}

ARG ironic_uid=2500001
ARG ironic_gid=2500001

RUN set -eux ; \
    BUILD_PACKAGES="gcc genisoimage git python3-dev patch" ; \
    REQUIRED_PACKAGES="ipmitool qemu-utils sudo which curl" ; \
    #
    apt-get update ; \
    apt-get install -y --no-install-recommends ${BUILD_PACKAGES} ${REQUIRED_PACKAGES} ; \
    #
    python3 -m venv /usr/venv-ironic ; \
    . /usr/venv-ironic/bin/activate ; \
    (git clone https://github.com/openstack/requirements.git --depth 1 --branch "${branch}" \
      || git clone https://github.com/openstack/requirements.git --depth 1 --branch "${openstack_release}-eol" \
      || git clone https://github.com/openstack/requirements.git --depth 1 --branch "unmaintained/${openstack_release}"); \
    (git clone https://github.com/openstack/ironic.git --depth 1 --branch "${branch}" \
      || git clone https://github.com/openstack/ironic.git --depth 1 --branch "${openstack_release}-eol" \
      || git clone https://github.com/openstack/ironic.git --depth 1 --branch "unmaintained/${openstack_release}") ; \
    pip3 install --no-cache-dir -c requirements/upper-constraints.txt pymysql python-memcached pymemcache ironic/ ; \
    #
    apt-get purge --auto-remove -y $BUILD_PACKAGES; \
    apt-get clean autoclean; \
    rm -rf /var/lib/apt/lists/* /root/.cache /var/lib/cache/* /requirements /root/.cache; \
    #
    groupadd --gid ${ironic_gid} ironic; \
    adduser --system --uid ${ironic_uid} --gid ${ironic_gid} ironic; \
    mkdir /etc/ironic; \
    chown -R ironic:ironic /etc/ironic;

ENV PATH="/usr/venv-ironic/bin:$PATH"
USER ironic

CMD ["ironic-api"]
